import java.io.*;
// jtux is the library that gives the POSIX interface.
import jtux.*;

// This is the class for a philosopher. You need to create
// a few of these in Philosophers.java.
public class Philosopher {
    int my_id; // Every philosopher will be given an id by you.
    int left_chopstick, right_chopstick; // The semaphores for the chopsticks.
    int riceBowl;

    // The constructor. id is just an id for the philosopher,
    // left will be a semaphore for the left chopstick
    // right will be a semaphore for the right chopstick
    // rice will be the rice bowl already created for you in
    // Philosophers.java. Just pass it along to this constructor.
    Philosopher(int id, int left, int right, int rice) {
	my_id = id;
	left_chopstick = left;
	right_chopstick = right;
	riceBowl = rice;
    }

    // This is the method you should call from the child to make
    // it run a philosopher.
    void run() {
	int ate = 99; // An arbitrary number > 0
	int stomach = 0; // Initially the philosopher has not had any rice.
	// The philosopher will loop as long as he/she succeeds in eating.
	// He/she will fail when the bowl is empty.
	while (ate > 0) {
	    try {
		// Here you should work.
		

		// Make the philosopher pick up its chopsticks
		// before he/she can eat. That is, have him/her
		// wait for them. Avoid deadlocks.
		

		// Use this to pause for a moment when you need to
		// see what's happening:
		Thread.sleep((long)(Math.random()*10000.0),0);

		// Here is the code for eating. You shouldn't have
		// to modify this:
		System.out.println("Philosopher " + my_id + " eating.");
		// Try to eat some:
		ate = Rice.eat(riceBowl);
		// If we succeed we add it to our stomach:
		if (ate > 0) stomach += ate;

		// Don't forget to make the philosopher put down the
		// chopsticks. That is, have him/her signal on them.

	    } catch (Exception e) {
		System.out.print("Exception: ");
		System.out.println(">" + e.toString() + "<");
	    }
	}
	System.out.println("Philosopher " + my_id + " leaves the table with " + stomach + " pieces of rice in his stomach.");
	UProcess.exit(0);
    }
}